<?php

#### inline markups ####
## small abbreviations `ABBR
Markup('`abbr','inline',"/`([[:upper:]]+)([[:lower:]])?\\b([.\/]$WikiWordPattern)?/e",
    "'$3' ? '$0' : '<tbook:visual markup=\"sc\">'.strtolower('$1').'</tbook:visual>$2'");

## '/cite/'
Markup("'/","<'''''","/'\/(.*?)\/'/",
    '<tbook:visual markup="sl">$1</tbook:visual>');

## '@keyboard@'
Markup("'@","<'''''","/'@(.*?)@'/",
    '<tbook:visual markup=\'sf\'>$1</tbook:visual>');

## marginal notes
Markup("{=",'inline',"/{=(.*?)(?:\|\s*(.*?))?=}/",
    '<tbook:mnote>$1</tbook:mnote>');

## highlight text
Markup("{*",'inline',"/{\*(.*?)\*}/",
    '<tbook:visual markup=\'hl\'>$1</tbook:visual>');

## ';small caps;'
Markup("';","<'''''","/';(.*?);'/",
    '<tbook:visual markup=\'sc\'>$1</tbook:visual>');

## nicer em dashes
Markup("s--s",'>--',"/\s+(&mdash;)\s+/",'&hairsp;$1&hairsp;');

## LaTeX entity ligatures
Markup('latex', "<'^", '/([`\/])?\\b(La[Tt]e[Xx])\\b/e',
  "('$1'=='/') ? '$1$2' : Keep('&LaTeX;');");
Markup('tech',"<'^",'/(\\/)?\\bTeX([[:lower:]])?/e',"'$1' ? '$1TeX$2' : Keep('&TeX;$2');");
Markup('bibtex',"<'^",'/(\\/)?\\b(Bib[Tt]e[Xx])\\b/e',
  "'$1' ? '$1$2' : 'B\'-IB-\''.Keep('&TeX;')");
$EnableTitleLatex = true;

## letter markup
if ($_GET['ptype']=='letter') {
  $LetterMarkupStyles = array(
    'S' => '%id=subject apply=block%(:nolinebreaks:)',
    'Y' => '%id=closing apply=block%(:linebreaks:)',
    'C' => '%id=copy apply=block%');
  Markup('addressee','<letter','/^(:?L:)(.*?)$/',
    '$1<tbook:wrap>$2</tbook:wrap>');
  Markup('countersign', '<letter', '/^:?N([QA]):/e',
    "SetPrintCountersignFmt(\$pagename,'$1')");
function SetPrintCountersignFmt($pagename,$type) {
  $GLOBALS['PrintCountersignFmt'] = TranslateCountersign($pagename,$type);
  return 'N:';
}
  $MarkupFrameBase['posteval']['letter'] =
  "\$out = preg_replace('/<tbook:p\s+[^>]*id=\'".
      "(letter|address|subject|opening|closing|name|copy|location|phone)".
      "\'>(.*?)\n<\/tbook:p>/se',\"LetterElements(PSS('$1'),PSS('$2'))\",\$out);";
Function LetterElements($type,$text) {
  $Preserve = array('letter', 'address', 'location', 'phone');
  $Elements = array(
    'letter'  => 'PrintToAddressFmt',
    'address' => 'PrintFromAddressFmt',
    'subject' => 'PrintHeaderFmt',
    'opening' => 'ActDescription',
    'closing' => 'PrintSubTitleFmt',
    'name'    => 'PrintNameFmt',
    'copy'    => 'PrintCCFmt',
    'location'=> 'PrintLocationFmt',
    'phone'   => 'PrintTelephoneFmt');
  if (in_array($type, $Preserve))
      SDV($GLOBALS[$Elements[$type]], str_replace('tbook:','',$text));
  else
      $GLOBALS[$Elements[$type]] = str_replace('tbook:','',$text);
  return '';
}
}

## Z; dropcaps markup
Markup('A;','block','/^([[:upper:]]);(([^;&]*(&[^;]+;)*)*);(.*)$/',
    '<:block><tbook:p skip="big"><tbook:lettrine initial=\'$1\'>$2</tbook:lettrine>$5</tbook:p>');

## [^footnote text^] and [^#^] to list footnotes
Markup("[^",'>links','/\[\^(.*?)\^\]/','<tbook:footnote>$1</tbook:footnote>');
Markup("^[^",'<[^','/^\[\^#\^\]$/','');
Markup('fn.','>style','/(<tbook:footnote>.*?<\/tbook:footnote>)(.)/e',
  "PSS(strstr('.,;:?!','$2') ? '$2$1' : '$1$2')");


## figure captions
Markup('fig','<links',
"/^=figure\s+((?:\[\[)?.*?$ImgExtPattern\"([^\"]*)\"(?:\]\])?)\s*(.*?)$/e",
    "'<:block><tbook:figure>'.PSS('$1').'<tbook:caption>'.
    (('$3'=='') ? PSS('$2') : PSS('$3')).'</tbook:caption></tbook:figure>'");


## =| centred text
Markup('^=|','block','/^=([?|])(.*)$/e',
    "'<:block><tbook:p '.(('$1'=='|') ? 'align=\'center\'' : 'skip=\"if\"').PSS('>$2</tbook:p>')");

## !run-in heads!and text
Markup('^!!','inline','/^!([^!]+?)([.?])?!/e',
   "'<tbook:visual markup=\'sf\'><tbook:visual markup=\'bf\'><tbook:style size=\'-1\'>'.PSS('$1').
   ('$2' ? '$2' : '.').' </tbook:style></tbook:visual></tbook:visual>'");

## aphorisms
Markup('^;;','block','/^;([^;]*);(.*?)$/e',
  "'<:block><tbook:blockquote'.
  ('$1' ? ' class=\"aphorism\"><tbook:caption>'.PSS('$1').'</tbook:caption' : '').
   '><tbook:p><tbook:quote class=\"pull\">'.PSS('$2').'</tbook:quote></tbook:p></tbook:blockquote>'");


## :+ for multiple <dd> per <dt> and multipar item lists
Markup(':+:','<^::','/^(:+.*?:)((?:.*?:\+.*?)+)$/e',
    "PSS('$1').'<tbook:p>'.str_replace(':+','</tbook:p><tbook:p>',PSS('$2')).'</tbook:p>'");
Markup(':+*','<^*','/^([#*]+)((?:.*?:\+.*?)+)$/e',
    "PSS('$1').'<tbook:p>'.str_replace(':+','</tbook:p><tbook:p>',PSS('$2')).'</tbook:p>'");
Markup(':+P','>:+*','/:\+/',
    '<tbook:newline vspace="0.3em" /><tbook:hspace dim="*1em" />');


## equations
$LatexrenderUrlFmt =
    "<tbook:latex kind=\"\$LinkClass\" code=\"\$LinkTitle\" />";
Markup('latexeq','<latexdm','/\{\$\s*([A-Za-z][-.:\\w]*)\s*,(.*?)\$\}/e',
    "LatexRWiki('equation','$2').'<tbook:wrap id=\"$1\" />'");
Markup('eqref','>latexr','/(E[Qq])\(([A-Za-z][-.:\\w]*)\)/e',
    "Keep(TBFigureRef(\$pagename,'$1','$2'),'L')");
Markup('tbwrapeq','>style',
      '/(<tbook:latex[^\/]*)\s*\/><tbook:wrap\s+(id=[^>]*>)/','$1 $2');

## figure and table references
SDV($ReferencePrefixFmt, array('EQ' => '$[equation]', 'FIG' => '$[figure]', 
    'TAB' => '$[table]', 'DIV' => '$[excerpt]'));
$FigureReferenceFmt = '<tbook:ref refid="$LinkID">$LinkText</tbook:ref>';
Markup('figref','inline','/(FIG|Fig|TAB|Tab|DIV|Div)\(([A-Za-z][-.:\\w]*)\)/e',
    "Keep(TBFigureRef(\$pagename,'$1','$2'),'L')");
Markup('cfloat', '<table','/^(\(:div.*?)\ssummary="([^"]*)"(.*?:\))\s*$/',
  '$1$3<tbook:caption>$2</tbook:caption>');


function TBFigureRef($pagename, $kind, $id, $pn='') {
  global $ReferencePrefixFmt, $FigureReferenceFmt, $ReferenceList;
  $ref = isset($ReferenceList[$id]) ? " ($ReferenceList[$id])" : '';
  if (strstr('FigTabEqDiv', $kind)) {
      $kind = strtoupper($kind);
      $txt = FmtPageName($ReferencePrefixFmt[$kind], $pagename);
      $txt[0] = strtoupper($txt[0]);
  } else
      $txt = FmtPageName($ReferencePrefixFmt[$kind], $pagename);
  return str_replace(array('$LinkID', '$LinkText'), array($id, $txt), 
    $FigureReferenceFmt) . $ref;
}

#Markup('latexr','inline','/\{\$(.*?)\$\}/e',
#   "'<tbook:latex code=\'$'.Keep(trim('$1')).'$\'></tbook:latex>'");
#   "'<tbook:m>'.Keep(trim('$1')).'</tbook:m>'");
#  "MimetexTbook('$1')");
#
#function MimetexTbook($tex) {
#  global $MimetexCmd;
#  $tex = trim($tex);
#  return Keep("<tbook:graphics kind=\"bitmap\" file=\"$MimetexCmd?$tex\" />");
#} 

## (:markup:) that excludes heading markup examples
function TbookHMarkupMarkup($pagename, $lead, $texta, $textb) {
  return "$lead<:block>" .
    Keep("<tbook:group class='frame'><tbook:verbatim>" . wordwrap($texta, 70) . 
    "</tbook:verbatim><tbook:hr style='dotted' />") .
    "\n$textb\n(:divend:)</tbook:group>\n";
}

Markup('`markup','<markup',
  "/(^|\\(:nl:\\))\\(:markup:\\)[^\\S\n]*\\[([=@])((?:\n`\\.!+.*?)+)\\2\\]/seim",
  "TbookHMarkupMarkup(\$pagename, '$1', PSS(str_replace('`.','','$3')), PSS('$3'))");

## (:notice:) markup for conditional notices
$Conditions['exists'] = "MultiPageExists(\$condparm,\$pagename)";
Markup('notice', 'block', '/^\(:notice\s+(.*?)\s*:\)$/',
    "<:block><tbook:notice kind='$1'>");
Markup('noticeend', 'block', '/^\(:noticeend:\)$/', "<:block></tbook:notice>");

function MultiPageExists($args, $pagename) {
  foreach(explode(' ', $args) as $v)
    if (PageExists(FmtPageName($v, $pagename))) return true;
  return false;
}

?>