<?php if (!defined('PmWiki')) exit();
/*
   search extensions script version 2.0.22
   Copyright 2004, 2005 John Rankin john.rankin@affinity.co.nz
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This file adds action=search and action=backlinks capabilities that 
   display search results in the current page. It turns the search box 
   into a jump box and adds a SearchQuickReference page.
*/

$HTMLStylesFmt[] = "
dl.fplbygroup dd { margin-bottom: 0; }
input.dictcheckbox { margin-left:0px; }
form.publish, dl.publish, input.publish { margin-left: 40px; margin-top: 10px; }
dl.publish dd { margin-bottom: 0; }";
SDV($HandleActions['search'],'HandleSearch');
SDV($HandleActions['searchinsitu'], 'HandleSearchA');
$SearchPatterns['normal'][] = '!\.SideBar$!';
$Transition['fplbygroup'] = 1;    // for pmwiki2.1 compatibioity
$MarkupFrameBase['posteval']['vspace'] =
    "\$out=str_replace('<vspace>','<div class=\"vspace\"></div>',\$out);";

if ($action=='backlinks') {
    $action = 'search';
    $SearchPatterns['normal'][] = FmtPageName('!^$FullName$!',$pagename);
    SDV($PageSearchFmt,array("<h1 class='wikiaction'>$[Pages that link to <a href='\$PageUrl' accesskey='b'>\$Group: \$Name</a>]</h1>",
                'markup:(:pagelist link=$FullName fmt=custom list=normal:)'));
    SDV($PageListFmt, "$HTMLVSpace\$MatchList");
    Markup('pagelist', 'directives',
      '/\\(:pagelist(\\s+.*?)?:\\)/ei',
      "'<:block>'.Keep(FmtPageList(\$GLOBALS['PageListFmt'], \$pagename, array('o' => PSS('$1 '))))");
} else
    SDV($PageSearchFmt,array("<h1 class='wikiaction'>$[Search Results]</h1>",
                         'markup:(:searchresults fmt=custom list=normal:)',
                         'wiki:$[Site.SearchQuickReference]'));
$FPLFunctions['custom'] = 'FPLCustom';
SDV($NoMatchesFmt,"<p class='indent'><em>$[No matches].</em></p>");
/*
SDV($SearchInSitu,true);
$SearchTagFmt = (preg_match('/^search(insitu)?/',$action) || preg_match('/\.Search(Wiki)?$/',$pagename)) ? 
    'Searching Wiki' :
    "<form action='\$PageUrl' method='get'>". (($SearchInSitu) ?
    "<a href='\$PageUrl?action=searchinsitu'>" :
  "<a href='\$ScriptUrl/$[Site.Search]'>") . "$[Search Wiki]</a>:
  <input type='hidden' name='n' value='\$FullName' />
  <input type='hidden' name='action' value='search' />
  <input class='searchbox' type='text' name='q' value='\$Group/' />
  <input class='searchbutton' type='submit' value='$[Go]' /></form>";
*/
$SearchBoxFmt = "<form class='wikisearch' action='\$PageUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' />
    <input type='hidden' name='action' value='search' />
    <input class='wikisearchbox' type='text' name='q' value='\$SearchQuery' size='40' />
    <input class='wikisearchbutton' type='submit' value='$[Search]' /></form>";

SDV($ActDescription,'last modified');
if ($action=='search') {
  $ActDescription = 'search performed';
  $text = stripmagic($_GET['q']); $jumpto='';
  if (preg_match("/^$GroupPattern([\\/.])$NamePattern$/",$text))
    $jumpto=$text;
  elseif (preg_match("/^$NamePattern$/",$text)) 
    $jumpto = (isset($_GET['group'])) ?
        stripmagic($_GET['group']).".$text" :
        FmtPageName("\$Group.$text",$pagename);
  if ($jumpto && PageExists($jumpto)) Redirect($jumpto);
}

SDV($PublishSearch,false);
SDV($PublishSearchChecked,false);
SDV($CategoryGroup,'Category');
XLSDV('en',array(
  'SearchFor' => (($action=='search' || isset($_GET['needle'])) ? 
    'Results of searching <em>$Haystack</em> for <em>$Needle</em>.' :
    'Pages in the <em>$Name</em> $Group'),
  'SearchFound' => '$MatchCount pages found out of $MatchSearched pages searched.'));

function Needle($incl,$excl) {
  $n = str_replace('$LQ$RQ','','$LQ'.join('$RQ and $LQ',$incl).'$RQ');
  foreach($excl as $w) { $n .= " not \$LQ$w\$RQ"; }
  if ($n) return str_replace('$LQ','&lsquo;',
                 str_replace('$RQ','&rsquo;',htmlspecialchars(trim($n))));
  else return 'all';
}

function FPLCustom($pagename,&$matches,$opt) {
  global $FPLByGroupStartFmt, $FPLByGroupEndFmt, $FPLByGroupGFmt,
    $FPLByGroupIFmt, $PublishSearch, $PublishSearchChecked, $CategoryGroup,
    $PDFCheckboxFmt, $PDFTypesetFmt, $PDFOptionsFmt, $HTMLVSpace;
  global $NoMatchesFmt,$FmtV,$FmtP;
  if ($PublishSearch) {
      $checked = ($PublishSearchChecked) ? "checked='checked'" : '';
      $FPLByGroupStartFmt =
    "<form class='publish' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' />
    <dl class='fplbygroup'>";
      $FPLByGroupEndFmt = "</dl>$HTMLVSpace
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='ptype' value='search' />";
      $FPLByGroupEndFmt .= (FmtPageName('$Group',$pagename)==$CategoryGroup) ?
            "<input type='hidden' name='category' value='\$FullName' />" :
            "<input type='hidden' name='needle' value='\$Needle' />
    <input type='hidden' name='haystack' value='\$Haystack' />";
      $FPLByGroupEndFmt .= "$PDFCheckboxFmt$PDFTypesetFmt$PDFOptionsFmt</form>";
      $FPLByGroupGFmt = "<dt><a href='\$ScriptUrl/\$Group'>\$Group</a></dt>";
      $FPLByGroupIFmt = 
    "<dd><input type='checkbox' name='pagearray[]' value='\$Group/\$Name' $checked/>
     <a href='\$PageUrl'>\$Title</a></dd>";
  }
  $FmtV['$Haystack'] = ($GLOBALS['SearchGroup']) ? 
    '&lsquo;'.$GLOBALS['SearchGroup'].'&rsquo; group' : 'all groups';
  $FmtV['$Needle'] = (@$opt['link']) ? '&lsquo;'.$opt['link'].'&rsquo; links' : 
    Needle($GLOBALS['SearchIncl'],$GLOBALS['SearchExcl']);
  $r = FPLByGroup($pagename,$matches,$opt);
  return (count($matches)==0) ? FmtPageName($NoMatchesFmt,$pagename) : Keep($r);
}

function HandleSearch($pagename, $level='read') {
  global $HandleSearchFmt,$PageStartFmt,$PageSearchFmt,$PageEndFmt,$FmtP;
  $FmtP['/\\$LastModified/e'] = '$GLOBALS[\'CurrentTime\']';
  SDV($HandleSearchFmt,array(&$PageStartFmt, &$PageSearchFmt, &$PageEndFmt));
  PrintFmt($pagename,$HandleSearchFmt);
}

?>